## gophernicus-1.7.tar.gz

=== Makefile ===
##
## Gophernicus server Makefile
##

#
# Variables and default configuration
#
NAME    = gophernicus
PACKAGE = $(NAME)
BINARY  = in.$(NAME)
VERSION = 1.7

SOURCES = $(NAME).c file.c menu.c string.c platform.c session.c options.c
HEADERS = functions.h files.h
OBJECTS = $(SOURCES:.c=.o)
DOCS    = LICENSE README INSTALL TODO ChangeLog README.Gophermap gophertag

INSTALL = PATH=$$PATH:/usr/sbin ./install-sh -o 0 -g 0
DESTDIR = /usr
SBINDIR = $(DESTDIR)/sbin
DOCDIR  = $(DESTDIR)/share/doc/$(PACKAGE)

ROOT    = /var/gopher
OSXROOT = /Library/GopherServer
WRTROOT = /gopher
MAP     = gophermap

INETD   = /etc/inetd.conf
XINETD  = /etc/xinetd.d
LAUNCHD = /Library/LaunchDaemons
PLIST   = org.gophernicus.server.plist
NET_SRV = /boot/common/settings/network/services

DIST    = $(PACKAGE)-$(VERSION)
TGZ     = $(DIST).tar.gz
RELDIR  = /var/gopher/gophernicus.org/software/gophernicus/

CC      = gcc
HOSTCC	= $(CC)
CFLAGS  = -O2 -Wall
LDFLAGS = 


#
# Platform support, compatible with both BSD and GNU make
#
all:
	@case `uname` in \
		Darwin)  $(MAKE) ROOT="$(OSXROOT)" $(BINARY); ;; \
		Haiku)   $(MAKE) EXTRA_LDFLAGS="-lnetwork" $(BINARY); ;; \
		*)       $(MAKE) $(BINARY); ;; \
	esac

generic: $(BINARY)


#
# Special targets
#
deb: ChangeLog
	dpkg-buildpackage -rfakeroot -uc -us

ChangeLog:
	if [ -d .git ]; then \
		(./git2changelog > .ChangeLog; \
		sed -ne '/2012-12-02/,$$p' ChangeLog >> .ChangeLog; \
		mv .ChangeLog ChangeLog); \
	else true; fi

.PHONY: ChangeLog


#
# Building
#
$(NAME).c: $(NAME).h $(HEADERS)
	
$(BINARY): $(OBJECTS)
	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(OBJECTS) -o $@

.c.o:
	$(CC) -c $(CFLAGS) $(EXTRA_CFLAGS) -DVERSION="\"$(VERSION)\"" -DDEFAULT_ROOT="\"$(ROOT)\"" $< -o $@


headers: $(HEADERS)
	@echo

functions.h:
	echo "/* Automatically generated function definitions */" > $@
	echo >> $@
	grep -h "^[a-z]" $(SOURCES) | \
		grep -v "int main" | \
		grep -v "strlc" | \
		sed -e "s/ =.*$$//" -e "s/ *$$/;/" >> $@
	@echo

bin2c: bin2c.c
	$(HOSTCC) bin2c.c -o $@
	@echo

files.h: bin2c
	sed -n -e "1,/^ $$/p" README > README.options
	./bin2c -0 -n README README.options > $@
	./bin2c -0 LICENSE >> $@
	./bin2c -n ERROR_GIF error.gif >> $@
	@echo


#
# Cleanup after building
#
clean: clean-build clean-deb

clean-build:
	rm -f $(BINARY) $(OBJECTS) $(TGZ) $(HEADERS) README.options bin2c .ChangeLog

clean-deb:
	if [ -d debian/$(PACKAGE) ]; then fakeroot debian/rules clean; fi


#
# Install targets
#
install: ChangeLog
	@case `uname` in \
		Darwin)  $(MAKE) ROOT="$(OSXROOT)" install-files install-docs install-root install-osx install-done; ;; \
		Haiku)   $(MAKE) SBINDIR=/boot/common/bin DOCDIR=/boot/common/share/doc/$(PACKAGE) \
		                 install-files install-docs install-root install-haiku install-done; ;; \
		*)       $(MAKE) install-files install-docs install-root; ;; \
	esac
	@if [ -d "$(XINETD)" ]; then $(MAKE) install-xinetd install-done; fi
	@if [ -f "$(INETD)" ]; then $(MAKE) install-inetd; fi

.PHONY: install

install-done:
	@echo
	@echo "======================================================================"
	@echo
	@echo "Gophernicus has now been succesfully installed. To try it out, launch"
	@echo "your favorite gopher browser and navigate to this URL:"
	@echo
	@echo "              gopher://`hostname`/"
	@echo
	@echo "======================================================================"
	@echo

install-files:
	mkdir -p $(SBINDIR)
	$(INSTALL) -s -m 755 $(BINARY) $(SBINDIR)
	@echo

install-docs:
	mkdir -p $(DOCDIR)
	$(INSTALL) -m 644 $(DOCS) $(DOCDIR)
	@echo

install-root:
	if [ ! -d "$(ROOT)" ]; then \
		mkdir -p $(ROOT); \
		$(INSTALL) -m 644 $(MAP) $(ROOT); \
		ln -s $(DOCDIR) $(ROOT)/docs; \
	fi
	@echo

install-inetd:
	@echo
	@echo "======================================================================"
	@echo
	@echo "Looks like your system has the traditional internet superserver inetd."
	@echo "Automatic installations aren't supported, so please add the following"
	@echo "line to the end of your /etc/inetd.conf and restart or kill -HUP the"
	@echo "inetd process."
	@echo
	@echo "gopher  stream  tcp  nowait  nobody  $(SBINDIR)/$(BINARY)  $(BINARY) -h `hostname`"
	@echo
	@echo "======================================================================"
	@echo

install-xinetd:
	if [ -d "$(XINETD)" -a ! -f "$(XINETD)/$(NAME)" ]; then \
		sed -e "s/@HOSTNAME@/`hostname`/g" $(NAME).xinetd > $(XINETD)/$(NAME); \
		[ -x /sbin/service ] && /sbin/service xinetd reload; \
	fi
	@echo

install-osx:
	if [ -d "$(LAUNCHD)" -a ! -f "$(LAUNCHD)/$(PLIST)" ]; then \
		sed -e "s/@HOSTNAME@/`hostname`/g" org.gophernicus.server.plist > \
			$(LAUNCHD)/$(PLIST); \
		launchctl load $(LAUNCHD)/$(PLIST); \
	fi
	@echo
	chown -h root:admin $(ROOT) $(ROOT)/*
	chmod -h 0775 $(ROOT) $(ROOT)/docs
	@echo

install-haiku:
	if [ -f "$(NET_SRV)" -a ! "`grep -m1 gopher $(NET_SRV)`" ]; then \
		(echo ""; \
		echo "service gopher {"; \
		echo "	family inet"; \
		echo "	protocol tcp"; \
		echo "	port 70"; \
		echo "	launch in.gophernicus -h `hostname`"; \
		echo "}") >> $(NET_SRV); \
	fi
	@echo
	chown user:root $(DOCDIR)/* $(SBINDIR)/$(BINARY) $(ROOT)/$(MAP)
	@echo
	ps | grep net_server | grep -v grep | awk '{ print $$2 }' | xargs kill
	nohup /boot/system/servers/net_server >/dev/null 2>/dev/null &
	@echo

#
# Uninstall targets
#
uninstall: uninstall-xinetd uninstall-launchd
	rm -f $(SBINDIR)/$(BINARY)
	for DOC in $(DOCS); do rm -f $(DOCDIR)/$$DOC; done
	rmdir -p $(SBINDIR) $(DOCDIR) 2>/dev/null || true
	@echo

uninstall-xinetd:
	if grep -q $(BINARY) "$(XINETD)/gopher" 2>/dev/null; then \
		rm -f $(XINETD)/gopher; \
		[ -x /sbin/service ] && service xinetd reload; \
	fi
	@echo

uninstall-launchd:
	if [ -f $(LAUNCHD)/$(PLIST) ]; then \
		launchctl unload $(LAUNCHD)/$(PLIST); \
		rm -f $(LAUNCHD)/$(PLIST); \
	fi
	if [ -L $(ROOT) ]; then \
		rm -f $(ROOT); \
	fi
	@echo


#
# Release targets
#
dist: clean functions.h ChangeLog
	mkdir -p /tmp/$(DIST)
	tar -cf - ./ --exclude=./.git | (cd /tmp/$(DIST) && tar -xf -)
	(cd /tmp/ && tar -cvf - $(DIST)) | gzip > $(TGZ)
	rm -rf /tmp/$(DIST)

release: dist
	cp $(TGZ) $(RELDIR)
	cp README INSTALL ChangeLog $(RELDIR)


#
# List all C defines
#
defines:
	$(CC) -dM -E $(NAME).c


#
# LOC
#
loc:
	@wc -l *.c

=== debian/changelog ===
gophernicus (1.7) unstable; urgency=low

  * New upstream release

 -- Kim Holviala <kim@holviala.com>  Mon, 02 Mar 2015 08:52:00 +0200

gophernicus (1.6) unstable; urgency=low

  * New upstream release

 -- Kim Holviala <kim@holviala.com>  Mon, 10 Nov 2014 11:27:06 +0200

gophernicus (1.5) unstable; urgency=low

  * New upstream release

 -- Kim Holviala <kim@holviala.com>  Sat, 25 Jan 2014 12:41:20 +0200

gophernicus (1.4) unstable; urgency=low

  * New upstream release

 -- Kim Holviala <kim@holviala.com>  Sun, 02 Dec 2012 09:54:55 +0200

gophernicus (1.3) unstable; urgency=low

  * New upstream release
  * Fixed one off-by-one

 -- Kim Holviala <kim@holviala.com>  Tue, 12 Jun 2012 13:07:46 +0300

gophernicus (1.2) unstable; urgency=low

  * New upstream release

 -- Kim Holviala <kim@holviala.com>  Fri, 04 May 2012 22:05:01 +0300

gophernicus (1.1) unstable; urgency=low

  * New upstream release
  * Security update, so upgrading is recommended

 -- Kim Holviala <kim@holviala.com>  Sat, 16 Oct 2010 08:54:13 +0300

gophernicus (1.0) unstable; urgency=low

  * Initial debianized release
  * File logging by default, installs logrotate config
  * Pre-configures php support but only suggests php5-cli
  * Create a default gopher root
  * Installs an @reboot cron entry to snoop system type
    using a dmidecode script (which must be run as root)

 -- Kim Holviala <kim@holviala.com>  Mon, 27 Sep 2010 08:11:12 +0300

=== debian/control ===
Source: gophernicus
Section: net
Priority: extra
Maintainer: Kim Holviala <kim@holviala.com>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.3
Homepage: gopher://gophernicus.org/1/software/gophernicus/server/

Package: gophernicus
Architecture: any
Depends: ${shlibs:Depends}, debconf, netbase, openbsd-inetd | inet-superserver
Recommends: lsb-release
Suggests: lynx, php5-cli
Description: Modern full-featured gopher server for inetd
 Gophernicus is a modern full-featured (and hopefully) secure
 gopher daemon for inetd.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Gophernicus debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Installation directory
DEST=$(CURDIR)/debian/gophernicus

configure:

build: build-stamp

build-stamp:
	dh_testdir

	$(MAKE)

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) clean-build

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/gophernicus
	$(MAKE) DESTDIR=$(DEST)/usr install-files
	rm -rf $(DEST)/tmp
	ln -s /usr/share/doc/gophernicus/ $(DEST)/var/gopher/docs
	ln -s /usr/bin/php5 $(DEST)/usr/lib/gophernicus/filters/php
	cp gophermap $(DEST)/usr/lib/gophernicus/

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
	dh_installdebconf	
	dh_installlogrotate
	dh_installlogcheck
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
